VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "www.ActiveVB.de"
   ClientHeight    =   3195
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command1 
      Caption         =   "ok"
      Height          =   375
      Left            =   3120
      TabIndex        =   1
      Top             =   2520
      Width           =   1215
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Zentriert
      Caption         =   "OS"
      Height          =   495
      Left            =   840
      TabIndex        =   0
      Top             =   1320
      Width           =   2655
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

' Danke an Heino fr den Tipp zum Erkennen, ob es sich um ein
' Windows 2000 System handelt.

' Danke an Jrgen fr den Tipp zum Erkennen, ob es sich um ein
' Windows ME System handelt.

Option Explicit
 
' Datentypen
Private Type OSVERSIONINFO
       dwOSVersionInfoSize As Long
       dwMajorVersion As Long
       dwMinorVersion As Long
       dwBuildNumber As Long
       dwPlatformId As Long
       szCSDVersion As String * 128 ' Service Pack
End Type

Private Type OSVERSIONINFOEX
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128 ' Service Pack
        wServicePackMajor As Integer
        wServicePackMinor As Integer
        wSuiteMask As Integer
        wProductType As Byte
        wReserved As Byte
End Type
 
' Enumerationen
Public Enum WindowsVersion
       WIN_OLD
       WIN_95
       WIN_98
       WIN_ME
       WIN_NT_3x
       WIN_NT_4x
       WIN_2K
       WIN_XP
       WIN_XP_HOME
       WIN_2003
End Enum

' WinAPI
Private Declare Function GetVersionEx1 Lib "kernel32.dll" Alias _
    "GetVersionExA" (ByRef lpVersionInformation As OSVERSIONINFO _
    ) As Long

Private Declare Function GetVersionEx2 Lib "kernel32.dll" Alias _
    "GetVersionExA" (ByRef lpVersionInformation As OSVERSIONINFOEX _
    ) As Long

' Konstanten
Private Const VER_PLATFORM_WIN32s As Long = 0&
Private Const VER_PLATFORM_WIN32_WINDOWS As Long = 1&
Private Const VER_PLATFORM_WIN32_NT As Long = 2&

' Um zu testen, ob XP Home oder Professional verwendet wird.
' Weitere Informationen gibt es unter
'
' http://msdn.microsoft.com/library/en-us/sysinfo/base/getversionex.asp
'
' http://msdn.microsoft.com/library/default.asp?url=/library/en-us/ ->
'     sysinfo/base/osversioninfoex_str.asp

Private Const VER_SUITE_PERSONAL As Long = &H200&
 
' Private Variablen
Private m_bAlreadyGot As Boolean
Private m_OsVersion As WindowsVersion

Private Sub Command1_Click()
    Unload Me
End Sub

Private Sub Form_Load()
    Select Case GetOSVersion
        Case WIN_OLD
            Label1 = "Windows 32s"
        
        Case WIN_95
            Label1 = "Windows 95"
        
        Case WIN_98
            Label1 = "Windows 98"
        
        Case WIN_ME
            Label1 = "Windows ME"
            
        Case WIN_NT_3x
            Label1 = "Windows NT 3"
        
        Case WIN_NT_4x
            Label1 = "Windows NT 4"
        
        Case WIN_2K
            Label1 = "Windows 2000"
        
        Case WIN_XP
            Label1 = "Windows XP"
        
        Case WIN_XP_HOME
            Label1 = "Windows XP Home Edition"
            
        Case WIN_2003
            Label1 = "Windows 2003"
    End Select
End Sub

'----------------------------------------------------
' GetOSVersion As WindowsVersion
' - Gibt die Betriebssystemversion zurck
'----------------------------------------------------
Public Function GetOSVersion() As WindowsVersion
    Dim OsVersInfoEx As OSVERSIONINFOEX
    Dim OsVersInfo As OSVERSIONINFO
    
    If m_bAlreadyGot Then
        GetOSVersion = m_OsVersion
        Exit Function
    End If
    
    ' Zuerst nehmen wir nur die kleinere Struktur um sicherzugehen,
    ' dass Windows 95 und Konsorten auch damit klarkommen
    OsVersInfo.dwOSVersionInfoSize = Len(OsVersInfo)
    
    If GetVersionEx1(OsVersInfo) = 0 Then
        MsgBox "Das Betriebssystem konnte nicht korrekt erkannt werden:" & _
                vbCrLf & "Fehler im API-Aufruf"
        
        m_OsVersion = WIN_OLD
        Exit Function
    End If
        
    With OsVersInfo
        Select Case .dwPlatformId
            Case VER_PLATFORM_WIN32s
                m_OsVersion = WIN_OLD
            Case VER_PLATFORM_WIN32_WINDOWS
                Select Case .dwMinorVersion
                    Case 0
                        m_OsVersion = WIN_95
                    Case 10
                        m_OsVersion = WIN_98
                    Case 90
                        m_OsVersion = WIN_ME
                End Select
            Case VER_PLATFORM_WIN32_NT
                Select Case .dwMajorVersion
                    Case 3
                        m_OsVersion = WIN_NT_3x
                    Case 4
                        m_OsVersion = WIN_NT_4x
                    Case 5
                        Select Case .dwMinorVersion
                            Case 0
                                m_OsVersion = WIN_2K
                            Case 1
                                
' Es handelt sich um Windows XP. Um zu erfahren, ob das verwendete
' Produkt eine Home-Edition ist, erfragen wir die Version erneut und
' empfangen dieses Mal die komplette Liste
                                
                                OsVersInfoEx.dwOSVersionInfoSize = _
                                    Len(OsVersInfoEx)
                                
                                If GetVersionEx2(OsVersInfoEx) = 0 Then
                                    MsgBox "Das Betriebssystem konnte nicht " & _
                                        "korrekt erkannt werden:" & _
                                        vbCrLf & "Fehler im API-Aufruf"
                                        
                                    m_OsVersion = WIN_XP
                                    Exit Function
                                End If
                                
                                If (OsVersInfoEx.wSuiteMask And VER_SUITE_PERSONAL) _
                                    = VER_SUITE_PERSONAL Then
                                    
                                    m_OsVersion = WIN_XP_HOME
                                Else
                                    m_OsVersion = WIN_XP
                                End If
                                
                            Case 2
                                m_OsVersion = WIN_2003
                        End Select
                End Select
        End Select
    End With
    
    GetOSVersion = m_OsVersion
    m_bAlreadyGot = True
End Function
